#include <linux/fcntl.h>
#include <linux/ioctl.h>
//#include <sys/ioctl.h>

#include <linux/gpio.h> // Required for the GPIO functions
#include <linux/hrtimer.h>
#include <linux/init.h>
#include <linux/interrupt.h> // Required for the IRQ code
#include <linux/kernel.h>
#include <linux/ktime.h>
#include <linux/module.h>
#include <linux/sched.h>
#include <linux/spi/spi.h>
#include <linux/spi/spidev.h>
#include <linux/types.h>

//#include <fcntl.h>
//#include <getopt.h>
#include <stdint.h>
//#include <stdio.h>
//#include <stdlib.h>
//#include <unistd.h>

#define MOD_DESC "SPI-DATA-GRABBER"

MODULE_DESCRIPTION(MOD_DESC);
MODULE_LICENSE("GPL v2");
MODULE_AUTHOR("d.stream engineering");

//////////////////////////// SPI ///////////////////////////////////

#define SPI_INVALID_BUS (-1)
int busnum = SPI_INVALID_BUS;
module_param(busnum, int, 0644);
MODULE_PARM_DESC(busnum, "SPI bus number");

unsigned int cs = 0;
module_param(cs, uint, 0644);
MODULE_PARM_DESC(cs, "SPI chip select");

#define SPI_MAX_BUS 16 /* take a reasonable number */

static struct spi_device* spidev;
static int spiFd = 0;

static __init int testfunc(void)
{
	int ret;
	int mode;

	ret = ioctl(1, 1, &mode);

	spiFd = open("/dev/spidev1.0", O_RDWR);
	return ret;
}

module_init(testfunc);
